orte/mca/oob/tcp/oob_tcp_msg.h File Reference.TH "orte/mca/oob/tcp/oob_tcp_msg.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/oob/tcp/oob_tcp_msg.h \- contains the data structure we will use to describe a message 
.SH SYNOPSIS
.br
.PP
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'mca/oob/oob.h'\fP
.br
\fC#include 'oob_tcp_peer.h'\fP
.br
\fC#include 'oob_tcp_hdr.h'\fP
.br
\fC#include <errno.h>\fP
.br
\fC#include 'opal/util/output.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_OOB_TCP_IOV_MAX\fP   16"
.br
.ti -1c
.RI "#define \fBMCA_OOB_TCP_MSG_ALLOC\fP(msg, rc)"
.br
.RI "\fIGet a new structure for use with a message. \fP"
.ti -1c
.RI "#define \fBMCA_OOB_TCP_MSG_RETURN\fP(msg)"
.br
.RI "\fIreturn a message structure that is no longer needed \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_oob_tcp_msg_t\fP \fBmca_oob_tcp_msg_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBmca_oob_tcp_type_t\fP { \fBMCA_OOB_TCP_POSTED\fP, \fBMCA_OOB_TCP_UNEXPECTED\fP }"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_oob_tcp_msg_t\fP)"
.br
.ti -1c
.RI "int \fBmca_oob_tcp_msg_wait\fP (\fBmca_oob_tcp_msg_t\fP *msg, int *size)"
.br
.RI "\fIWait for a msg to complete. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_msg_timedwait\fP (\fBmca_oob_tcp_msg_t\fP *msg, int *size, struct timespec *ts)"
.br
.RI "\fIWait - up to a timeout - for a msg to complete. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_msg_complete\fP (\fBmca_oob_tcp_msg_t\fP *msg, orte_process_name_t *peer)"
.br
.RI "\fISignal that a message has completed. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_msg_copy\fP (\fBmca_oob_tcp_msg_t\fP *msg, struct iovec *iov, int count)"
.br
.RI "\fICalled to copy the results of a message into user supplied iovec array. \fP"
.ti -1c
.RI "bool \fBmca_oob_tcp_msg_send_handler\fP (\fBmca_oob_tcp_msg_t\fP *msg, struct \fBmca_oob_tcp_peer_t\fP *peer)"
.br
.RI "\fICalled asynchronously to progress sending a message from the event library thread. \fP"
.ti -1c
.RI "bool \fBmca_oob_tcp_msg_recv_handler\fP (\fBmca_oob_tcp_msg_t\fP *msg, struct \fBmca_oob_tcp_peer_t\fP *peer)"
.br
.RI "\fICalled asynchronously to progress sending a message from the event library thread. \fP"
.ti -1c
.RI "void \fBmca_oob_tcp_msg_recv_complete\fP (\fBmca_oob_tcp_msg_t\fP *msg, struct \fBmca_oob_tcp_peer_t\fP *peer)"
.br
.RI "\fIThe message has been completely received - so attempt to match against posted recvs. \fP"
.ti -1c
.RI "\fBmca_oob_tcp_msg_t\fP * \fBmca_oob_tcp_msg_match_recv\fP (orte_process_name_t *name, int tag)"
.br
.RI "\fIMatch name to a message that has been received asynchronously (unexpected). \fP"
.ti -1c
.RI "\fBmca_oob_tcp_msg_t\fP * \fBmca_oob_tcp_msg_match_post\fP (orte_process_name_t *name, int tag)"
.br
.RI "\fIMatch name to a posted recv request. \fP"
.ti -1c
.RI "static struct iovec * \fBmca_oob_tcp_msg_iov_alloc\fP (\fBmca_oob_tcp_msg_t\fP *msg, int count)"
.br
.RI "\fIAllocate space for iovec array - if the request number of elements is less than MCA_OOB_TCP_IOV_MAX then use the array allocated along w/ the message - otherwise allocate count elements. \fP"
.ti -1c
.RI "static void \fBmca_oob_tcp_msg_iov_return\fP (\fBmca_oob_tcp_msg_t\fP *msg, struct iovec *iov)"
.br
.RI "\fIRelease resource held by iovec array if this is not part of the message. \fP"
.in -1c
.SH "Detailed Description"
.PP 
contains the data structure we will use to describe a message 


.SH "Define Documentation"
.PP 
.SS "#define MCA_OOB_TCP_MSG_ALLOC(msg, rc)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    opal_list_item_t* item; \
    OPAL_FREE_LIST_GET(&mca_oob_tcp_component.tcp_msgs, item, rc); \
    msg = (mca_oob_tcp_msg_t*)item; \
    }
.fi
Get a new structure for use with a message. 
.PP
.SS "#define MCA_OOB_TCP_MSG_RETURN(msg)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    /* frees the iovec allocated during the send/receive */ \
    if(NULL != msg->msg_rwiov) \
        mca_oob_tcp_msg_iov_return(msg,msg->msg_rwiov); \
    if(NULL != msg->msg_rwbuf) \
        free(msg->msg_rwbuf); \
    OPAL_FREE_LIST_RETURN(&mca_oob_tcp_component.tcp_msgs, (opal_list_item_t*)msg); \
    }
.fi
return a message structure that is no longer needed 
.PP
.SH "Function Documentation"
.PP 
.SS "int mca_oob_tcp_msg_complete (\fBmca_oob_tcp_msg_t\fP * msg, orte_process_name_t * peer)"
.PP
Signal that a message has completed. 
.PP
Wakes up any pending threads (for blocking send) or invokes callbacks for non-blocking case. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message send/recv that has completed. 
.br
\fIpeer\fP (IN) The peer the send/receive was from 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP or error code on failure. 
.RE
.PP

.SS "int mca_oob_tcp_msg_copy (\fBmca_oob_tcp_msg_t\fP * msg, struct iovec * iov, int count)"
.PP
Called to copy the results of a message into user supplied iovec array. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message send that is in progress. 
.br
\fIiov\fP (IN) Iovec array of user supplied buffers. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIcount\fP Number of elements in iovec array. 
.RE
.PP

.SS "static struct iovec* mca_oob_tcp_msg_iov_alloc (\fBmca_oob_tcp_msg_t\fP * msg, int count)\fC [inline, static]\fP"
.PP
Allocate space for iovec array - if the request number of elements is less than MCA_OOB_TCP_IOV_MAX then use the array allocated along w/ the message - otherwise allocate count elements. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message to allocate array. 
.br
\fIcount\fP (IN) the number of iovecs 
.RE
.PP
\fBReturns:\fP
.RS 4
Array of iovec elements. 
.RE
.PP

.SS "static void mca_oob_tcp_msg_iov_return (\fBmca_oob_tcp_msg_t\fP * msg, struct iovec * iov)\fC [inline, static]\fP"
.PP
Release resource held by iovec array if this is not part of the message. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message to allocate array. 
.br
\fIiov\fP (IN) Iovec array to return. 
.RE
.PP

.SS "\fBmca_oob_tcp_msg_t\fP* mca_oob_tcp_msg_match_post (orte_process_name_t * name, int tag)"
.PP
Match name to a posted recv request. 
.PP
\fBParameters:\fP
.RS 4
\fIname\fP (IN) Name associated with peer or wildcard to match first posted recv. 
.br
\fItag\fP (IN) Message tag. 
.RE
.PP
\fBReturns:\fP
.RS 4
msg Matched message or NULL.
.RE
.PP
Note - this routine requires the caller to be holding the module lock. 
.SS "\fBmca_oob_tcp_msg_t\fP* mca_oob_tcp_msg_match_recv (orte_process_name_t * name, int tag)"
.PP
Match name to a message that has been received asynchronously (unexpected). 
.PP
\fBParameters:\fP
.RS 4
\fIname\fP (IN) Name associated with peer or wildcard to match first posted recv. 
.br
\fItag\fP (IN) Message tag. 
.RE
.PP
\fBReturns:\fP
.RS 4
msg Matched message or NULL.
.RE
.PP
Note - this routine requires the caller to be holding the module lock. 
.SS "bool mca_oob_tcp_msg_recv_handler (\fBmca_oob_tcp_msg_t\fP * msg, struct \fBmca_oob_tcp_peer_t\fP * peer)"
.PP
Called asynchronously to progress sending a message from the event library thread. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message send that is in progress. 
.br
\fIpeer\fP (IN) Peer theat we are recieving from. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIbool\fP Bool flag indicating wether operation has completed. 
.RE
.PP

.SS "bool mca_oob_tcp_msg_send_handler (\fBmca_oob_tcp_msg_t\fP * msg, struct \fBmca_oob_tcp_peer_t\fP * peer)"
.PP
Called asynchronously to progress sending a message from the event library thread. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message send that is in progress. 
.br
\fIpeer\fP (IN) Peer we are sending to. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINumber\fP of bytes copied. 
.RE
.PP

.SS "int mca_oob_tcp_msg_timedwait (\fBmca_oob_tcp_msg_t\fP * msg, int * size, struct timespec * ts)"
.PP
Wait - up to a timeout - for a msg to complete. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message to wait on. 
.br
\fIsize\fP (OUT) Number of bytes delivered. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP or error code on failure. 
.RE
.PP

.SS "int mca_oob_tcp_msg_wait (\fBmca_oob_tcp_msg_t\fP * msg, int * size)"
.PP
Wait for a msg to complete. 
.PP
\fBParameters:\fP
.RS 4
\fImsg\fP (IN) Message to wait on. 
.br
\fIsize\fP (OUT) Number of bytes delivered. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP or error code on failure. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
